#!/usr/bin/env python
# -*- coding: utf-8 -*-
##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

import pygtk
pygtk.require('2.0')
import gtk

import common

class AlbumCommenter(gtk.Entry):
    def __init__(self,canModify=True):
        gtk.Entry.__init__(self)
        self.connect("activate",self.save)
        self.hide()

        self.set_editable(canModify)

    def set(self,nodeFolder):
        if nodeFolder.getPhotos():  # if nodefolder contains some photos it can be commented
            self.show()
            self.set_text(nodeFolder.comment)
            self.__nf = nodeFolder
        else:
            self.hide()
            self.__nf=None

    def save(self,e):
        if self.__nf:
            self.__nf.setComment( self.get_text().decode("utf_8") )

class WinWait(gtk.Window):
    def delete_event(self, event, data=None):
        return False

    def __init__(self,parent):
        gtk.Window.__init__(self,gtk.WINDOW_POPUP)

        self.pg = gtk.ProgressBar()
        self.add(self.pg)

        self.set_transient_for(parent)
        self.set_modal(True)
        self.set_keep_above(True)
        #~ w,h=parent.get_size()
        #~ self.set_size_request(w,30)
        #~ x,y=parent.get_position()
        #~ self.move(x, y+h-30)
        self.set_size_request(200,30)
        self.set_position(gtk.WIN_POS_CENTER_ON_PARENT)

        self.show_all()

    def set(self,percent=None,msg=None):
        if percent>=0.0 and percent<=1.0:
            self.pg.set_fraction(percent)
        if msg!=None:
            self.pg.set_text(msg)

class WinShow(gtk.EventBox):

    def delete_event(self, event, data=None):
        return False

    def __init__(self,ln,idx):
        gtk.EventBox.__init__(self)

        self.ln = ln
        self.idx=idx

        tbl = gtk.Table(2, 2, False)
        self.__img = gtk.Image()
        self.__lbl = gtk.Label("-")
        self.__lbl.set_line_wrap(True)
        #~ self.__txt = gtk.Entry()
        #~ tbl.attach(self.__txt,0,2,0,1)
        tbl.attach(self.__img,0,1,0,2)
        tbl.attach(self.__lbl,1,2,0,2)

        #~ self.__txt.connect("activate",self.save)

        self.add(tbl)
        self.connect("button_press_event", self.onClick)
        self.connect("key_press_event", self.onKeyDown)
        self.connect("scroll_event", self.onScroll)


        self.win=gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.win.connect("delete_event", self.delete_event)
        self.win.set_modal(True)
        self.win.set_keep_above(True)
        #~ self.window.set_position(gtk.WIN_POS_CENTER_ON_PARENT)
        #~ self.win.set_size_request(800,600)
        self.win.fullscreen()
        self.win.add(self)
        self.win.show_all()
        self.win.set_title("Jbrout Show")

        self.size = gtk.gdk.screen_height()
        self.__img.set_size_request(self.size,self.size)

        self.show()
        self.__img.set_flags(gtk.CAN_FOCUS)
        self.__img.grab_focus()

        #~ if comment:
            #~ self.__txt.show()
            #~ self.__txt.grab_focus()
        #~ else:
            #~ self.__txt.hide()

    def onClick(self,w,e):
        self.win.hide()
        self.win.destroy()
        return 1

    def onKeyDown(self,a,b):
        print b.keyval
        if (b.keyval == 65365) or (b.keyval == 65362) or (b.keyval == 65361):
            self.idx-=1
            self.show()
        elif b.keyval == 65366 or (b.keyval == 65363) or (b.keyval ==65364):
            self.idx+=1
            self.show()
        elif b.keyval == 65360: # HOME
            self.idx=0
            self.show()
        elif b.keyval == 65367: # END
            self.idx=len(self.ln) -1
            self.show()
        elif b.keyval == 65307: #ESC
            self.onClick(1,1)
        #~ print b.keyval

    def onScroll(self,a,b):
        if int(b.direction)==1:
            self.idx+=1
        else:
            self.idx-=1

        self.show()

    #~ def save(self,e):
        #~ if self.__txtNode:
            #~ self.__txtNode.setComment( self.__txt.get_text().decode("utf_8") )
            #~ self.idx+=1
            #~ self.show()
            #~ self.__txt.grab_focus()

    def show(self):
        if self.idx >= len(self.ln):
            self.idx = len(self.ln)-1
        if self.idx < 0:
            self.idx = 0

        node = self.ln[self.idx]
        info = node.getInfo()
        #~ self.__txtNode = node
        #~ self.__txt.set_text(info["comment"])
        msg = """
(%d/%d)
%s

FOLDER :
%s\n
RESOLUTION:
%s\n
TAGS :
%s\n
COMMENT :
%s\n
EXIF DATE :
%s\n
FILE DATE :
%s\n""" % (
                self.idx+1,len(self.ln),
                node.name,
                " /".join( node.folder.split("/")),
                info["resolution"],
                ", ".join(info["tags"]),
                info["comment"],
                common.cd2rd(info["exifdate"]),
                common.cd2rd(info["filedate"])
            )
            #~ MessageBox(None,"info",msg)

        pb = node.getImage()
        (wx,wy) = pb.get_width(),pb.get_height()
        rx=1.0*wx/self.size
        ry=1.0*wy/self.size
        if rx>ry:
            rr=rx
        else:
            rr=ry
        pb = pb.scale_simple(int(wx/rr),int(wy/rr),gtk.gdk.INTERP_NEAREST)

        self.__img.set_from_pixbuf(pb)
        self.__lbl.set_text( msg )


def InputBox(parent,titre,data):
    dialog = gtk.Dialog("Interactive Dialog", parent, 0,
            (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OK, gtk.RESPONSE_OK))
    dialog.set_default_response(gtk.RESPONSE_OK)

    hbox = gtk.HBox(False, 8)
    hbox.set_border_width(8)
    dialog.vbox.pack_start(hbox, False, False, 0)

    stock = gtk.image_new_from_stock(
            gtk.STOCK_DIALOG_QUESTION,
            gtk.ICON_SIZE_DIALOG)
    hbox.pack_start(stock, False, False, 0)

    table = gtk.Table(2, 2)
    table.set_row_spacings(4)
    table.set_col_spacings(4)
    hbox.pack_start(table, True, True, 0)

    label = gtk.Label(titre)
    label.set_use_underline(True)
    table.attach(label, 0, 2, 0, 1)
    local_entry1 = gtk.Entry()
    local_entry1.set_text(data)
    local_entry1.connect("activate", lambda w : dialog.response(gtk.RESPONSE_OK))
    table.attach(local_entry1, 0, 2, 1, 2)
    label.set_mnemonic_widget(local_entry1)


    dialog.show_all()

    response = dialog.run()

    if response == gtk.RESPONSE_OK:
        ret= local_entry1.get_text().decode("utf_8")
    else:
        ret = None
    dialog.destroy()

    return ret

def MessageBox(parent,titre,data):
    dialog = gtk.Dialog(titre, parent, 0,
            (gtk.STOCK_OK, gtk.RESPONSE_OK)
            )
    dialog.set_default_response(gtk.RESPONSE_OK)

    hbox = gtk.HBox(False, 8)
    hbox.set_border_width(8)
    dialog.vbox.pack_start(hbox, False, False, 0)

    stock = gtk.image_new_from_stock(
            gtk.STOCK_DIALOG_INFO,
            gtk.ICON_SIZE_DIALOG)
    hbox.pack_start(stock, False, False, 0)

    table = gtk.Table(2, 2)
    table.set_row_spacings(4)
    table.set_col_spacings(4)
    hbox.pack_start(table, True, True, 0)

    label = gtk.Label(data)
    label.set_selectable(True)
    table.attach(label, 0, 2, 0, 1)

    dialog.show_all()

    response = dialog.run()

    dialog.destroy()

def InputQuestion(parent,titre):
    dialog = gtk.Dialog("Interactive Dialog", parent, 0,
            (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OK, gtk.RESPONSE_OK))
    dialog.set_default_response(gtk.RESPONSE_OK)

    hbox = gtk.HBox(False, 8)
    hbox.set_border_width(8)
    dialog.vbox.pack_start(hbox, False, False, 0)

    stock = gtk.image_new_from_stock(
            gtk.STOCK_DIALOG_QUESTION,
            gtk.ICON_SIZE_DIALOG)
    hbox.pack_start(stock, False, False, 0)

    table = gtk.Table(2, 2)
    table.set_row_spacings(4)
    table.set_col_spacings(4)
    hbox.pack_start(table, True, True, 0)

    label = gtk.Label(titre)
    label.set_use_underline(True)
    table.attach(label, 0, 2, 0, 1)
    #~ local_entry1 = gtk.Entry()
    #~ local_entry1.set_text(data)
    #~ table.attach(local_entry1, 0, 2, 1, 2)
    #~ label.set_mnemonic_widget(local_entry1)


    dialog.show_all()

    response = dialog.run()

    if response == gtk.RESPONSE_OK:
        ret= True
    else:
        ret = False
    dialog.destroy()

    return ret

##############################################################################
##############################################################################
##############################################################################

from StringIO import StringIO
from libs import exif
import os

def rgb(r,g,b,a=00):
    return r*256*256*256 + g*256*256 + b*256 + a

class Img(object):
    def __init__(self,file=None,thumb=None,im=None):
        if file:
            try:
                im = gtk.gdk.pixbuf_new_from_file( file )
            except IOError:
                raise IOError #"Img() : file not found"
        elif thumb:
            try:
                fid = open(thumb, 'rb')
                jo = exif.process_file(fid)
                fid.close()

                data = jo["JPEGThumbnail"]
                loader = gtk.gdk.PixbufLoader ('jpeg')

                loader.write (data, len (data))
                im = loader.get_pixbuf ()
                loader.close ()
            except IOError:
                raise IOError #"Img() : file not found"
            except KeyError,detail:
                raise KeyError #"Img() : no exif inside"
        elif im:
            pass
        else:
            raise Exception #"Img() : bad call"

        self.__im = im

    def __getWidth(self):
        return self.__im.get_width()
    width = property(__getWidth)
    def __getHeight(self):
        return self.__im.get_height()
    height = property(__getHeight)

    def __getPixbuf(self):    # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        return self.__im
    pixbuf = property(__getPixbuf)

    #~ def getStreamJpeg(self,quality=70):
        #~ f = StringIO()
        #~ self.__im.save(f, "jpeg",quality=quality)
        #~ f.seek(0)
        #~ return f


    def resize(self,size):
        pb = self.__im
        (wx,wy) = self.width,self.height
        rx=1.0*wx/size
        ry=1.0*wy/size
        if rx>ry:
            rr=rx
        else:
            rr=ry

        pb = pb.scale_simple(int(wx/rr), int(wy/rr) ,3)   # 3= best quality (gtk.gdk.INTERP_HYPER)
        return Img(im=pb)

    def resizeC(self,size,color=rgb(0,0,0)):
        pb = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB,0,8,size,size)
        pb.fill(color)

        newimg = self.resize(size)

        if newimg.width == size:
            x=0
            y=(size - newimg.height)/2
        else:
            x=(size - newimg.width)/2
            y=0
        newimg.__im.copy_area(0,0,newimg.width,newimg.height,pb,x,y)
        return Img(im=pb)

    def save(self,dest,quality=80,format="jpeg"):
        assert type(dest)==unicode
        self.__im.save(dest, format, {"quality":str(quality)})


if __name__ == "__main__":
    pass