#!/usr/bin/env python
# -*- coding: utf-8 -*-

##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

import glob,os,sys

#---------------------------------------------------
# imported by plugins
#---------------------------------------------------
def _(m):
    return m

class JPlugin:
    # self.parent : fenetre parente
    def __init__(self):
        self.init()
#---------------------------------------------------

class JPlugins:
    path = "plugins"

    def __init__(self):
      pObj = {}
      pDir = glob.glob("%s/*"%JPlugins.path)
      for i in pDir:
         if os.path.isdir(i):
            d,n = os.path.split(i)
            try:
                plug = __import__( "%s.%s" % (d,n) , globals(), globals(), ['create'] )
                plug.path = i
                pObj[n] = plug
            except:
                print "Plugin Error for '%s' : %s" % (n,sys.exc_info()[0])

      self.data = pObj

    def list(self):
      """ return a [] of plugin's name """
      return self.data.keys()

    def __str__( self ):
      """ print info about the plugins """
      m=""
      LF="\n"
      for n in self.data:
         i=self.data[n]
         title = "[%s] : %s %s by %s" % (n,i.__name__,i.__version__,i.__author__)
         m+= title +LF
         m+= len(title)*"-" +LF
         m+= i.__doc__ + LF
         m+= LF
      return m

    def __getitem__(self,n):
      if n in self.data:
         return self.data[n]
      else:
         raise "plugin name error"

#======================================================================
class PluginsManager:

    def __init__(self):
        self.__plugs = JPlugins()

        self.__data=[]
        for i in self.__plugs.data:
            for order,nom,cde in self.__plugs.data[i].menuEntries:
                self.__data.append( (order,i,nom,cde,self.__plugs.data[i].__alter__) ) # order == id

        self.__data.sort(cmp=lambda x,y: cmp(x[0],y[0]) )


    def getEntries(self):
        return self.__data

    def do(self,id,list):
        find=False
        for i,nom,menu,cde,alter in self.__data:
            if i==id:
                find=True
                break

        ret=False
        if find:
            cpath = os.getcwdu()
            os.chdir(self.__plugs[ nom ].path)
            plug = self.__plugs[ nom ].Create( nom )
            ret= plug.select(cde,list)
            os.chdir(cpath)
        else:
            raise "plugin strange %d" % id

        return ret



if __name__=="__main__":
    p = PluginsManager()
    print p.getEntries()


    p = JPlugins()
    print p.list()
    print p
