#!/usr/bin/env python
# -*- coding: UTF8 -*-

# Python module comment.py
# Autogenerated from comment.glade
# Generated on Fri May 20 08:57:17 2005

# Warning: Do not delete or modify comments related to context
# They are required to keep user's code

import os
import gtk
from SimpleGladeApp import SimpleGladeApp

glade_dir = ""

# Put your modules and data here

# From here through main() codegen inserts/updates a class for
# every top-level widget in the .glade file.

class WinComment(SimpleGladeApp):
    def __init__(self, glade_path="comment.glade", root="winComment", domain=None):
        glade_path = os.path.join(glade_dir, glade_path)
        SimpleGladeApp.__init__(self, glade_path, root, domain)

    def new(self):
        #context WinComment.new {
        
        #############################################################
        ## IN in self.nodes:
        ##  - a list of PhotoNodes()
        ##
        ##
        ## OUT in self.reponse:
        ##  - boolean False : operation abandonned
        ##  - string : one comment for all the pictures
        ##  - [string,] : multi comments 
        #############################################################
        self.main_widget.set_modal(True)
        self.main_widget.set_keep_above(True)
        self.main_widget.set_position(gtk.WIN_POS_CENTER)

        self.list=[]
        for i in self.nodes:
            b = gtk.TextBuffer()
            b.set_text(i.comment)
            self.list.append( (i,b) )
            
        self.lbl_all.set_text("%d photo(s)" % len(self.list))
        if len(self.nodes)==1:
            self.tv_all_comment.get_buffer().set_text(self.nodes[0].comment)
            self.notebook1.remove_page(1)
            self.tv_all_comment.grab_focus()
        else:
            self.hscrollbar1.set_range(0,len(self.list)-1)
            self.hscrollbar1.set_increments(1,1)
            self.setPhoto(0)
        
        #context WinComment.new }

    #context WinComment custom methods {
    #--- Write your own methods here ---#
    def setPhoto(self,i):
        info = self.list[i]
        node = info[0]
        self.lbl_one.set_text( "Photo %d/%d : %s " % (i+1,len(self.list),node.name) )
        self.image1.set_from_pixbuf( node.getThumb() )
        self.tv_comment.set_buffer( info[1] )
    def getTextFromBuffer(self,b):
        start=b.get_start_iter()
        end =b.get_end_iter() 
        txt= b.get_text(start,end,False)
        txt = txt.replace("\r","")
        txt= txt.strip()
        return txt.decode("utf_8")
    #context WinComment custom methods }

    def on_winComment_delete_event(self, widget, *args):
        #context WinComment.on_winComment_delete_event {
        self.reponse=False
        self.main_widget.destroy()
        gtk.main_quit()
        #context WinComment.on_winComment_delete_event }

    def on_notebook1_switch_page(self, widget, *args):
        #context WinComment.on_notebook1_switch_page {
        gpoint,page= args
        if page==0:
            self.tv_all_comment.grab_focus()
        else:
            self.tv_comment.grab_focus()
            
        #context WinComment.on_notebook1_switch_page }

    def on_hscrollbar1_value_changed(self, widget, *args):
        #context WinComment.on_hscrollbar1_value_changed {
        sel = int(widget.get_value())
        self.setPhoto(sel)
        #context WinComment.on_hscrollbar1_value_changed }

    def on_tv_comment_key_press_event(self, widget, *args):
        #context WinComment.on_tv_comment_key_press_event {
        event=args[0]
        if event.get_state() & gtk.gdk.CONTROL_MASK:
            if event.keyval == 65365:
                self.hscrollbar1.set_value( self.hscrollbar1.get_value()-1 )
            elif event.keyval in [65366,65293]:
                self.hscrollbar1.set_value( self.hscrollbar1.get_value()+1 )
            elif event.keyval == 65360: # HOME
                self.hscrollbar1.set_value(0)
            elif event.keyval == 65367: # END
                self.hscrollbar1.set_value(len(self.list)-1)
            return True # don't do the key !
            
        #context WinComment.on_tv_comment_key_press_event }

    def on_btn_annuler_clicked(self, widget, *args):
        #context WinComment.on_btn_annuler_clicked {
        self.reponse=False
        self.main_widget.destroy()
        gtk.main_quit()

        #context WinComment.on_btn_annuler_clicked }

    def on_btn_ok_clicked(self, widget, *args):
        #context WinComment.on_btn_ok_clicked {
        selectedTab = self.notebook1.get_current_page()
        if selectedTab==0:
            # comment all
            self.reponse=self.getTextFromBuffer( self.tv_all_comment.get_buffer() )
        else:
            # comment one by one
            self.reponse=[self.getTextFromBuffer( b ) for n,b in self.list]
        self.main_widget.destroy()
        gtk.main_quit()

        #context WinComment.on_btn_ok_clicked }

def main():
    win_comment = WinComment()

    win_comment.run()

if __name__ == "__main__":
    main()
