#!/usr/bin/env python
# -*- coding: utf-8 -*-

##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

"""Plugin pour exporter les photos selectionnes vers un repertoire
(possibilite de les redimensionner au passage)"""
from __main__ import JPlugin,_

from export import WindowExport

import os,time,shutil

__name__ = "Export"
__author__ = "manatlan"
__version__ = "1.0"
__alter__ = False          # to prevent jbrout if this plugin can alter DB or photos
menuEntries= [(3000,_("Export to"),"go")]

class Create(JPlugin):

    """
    self.conf                           : indexer on self configuration
    self.showProgress(cur,max,msg)      : show progress bar
    self.parent                         : parent gtk window
    """

    def init(self):
        pass

    def select(self,cde,list):
        window_export = WindowExport()

        window_export.entry.set_text( self.conf["path"] or "" )
        window_export.notebook1.set_current_page(self.conf["mode"] or 0)
        window_export.hscale_quality.set_value( float(self.conf["quality"] or 100) )
        window_export.hscale_size.set_value( float(self.conf["size"] or 100))

        window_export.run()
        if window_export.reponse:
            path,mode,qual,size = window_export.reponse
            self.conf["path"]=path
            self.conf["mode"]=mode
            self.conf["quality"]=qual
            self.conf["size"]=size

            del(window_export)

            dir = path + "/Jbrout " + time.strftime("%Y-%m-%d, %H-%M-%S")
            os.mkdir(dir)

            try:
                for pnode in list:
                    self.showProgress( list.index(pnode), len(list) , _("Exporting") )
                    file = pnode.file

                    dest = os.path.join( dir, pnode.name)
                    while os.path.isfile(dest):
                        dest = os.path.join( dir, pnode.giveMeANewName() )

                    if mode==1: # reduced
                        pb = pnode.getImage() # a gtk.PixBuf
                        (wx,wy) = pb.get_width(),pb.get_height()
                        wx = int(wx*size / 100)
                        wy = int(wy*size / 100)
                        pb = pb.scale_simple(wx,wy,3)   # 3= best quality (gtk.gdk.INTERP_HYPER)
                        pb.save(dest, "jpeg", {"quality":str(int(qual))})
                    else:
                        shutil.copy2(file,dest)
            finally:
                self.showProgress()

        return False
