#!/usr/bin/env python
# -*- coding: utf-8 -*-
##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

""" export to html """
from __main__ import JPlugin,_

from export import WindowExport
from lxml.etree import Element,ElementTree,parse,XSLT

import os,time,shutil

__name__ = "Export.html"
__author__ = "manatlan"
__version__ = "1.0"
__alter__ = False          # to prevent jbrout if this plugin can alter DB or photos
menuEntries= [(3100,_("Export to Html"),"go")]

class Create(JPlugin):

    """
    self.conf                           : indexer on self configuration
    self.showProgress(cur,max,msg)      : show progress bar
    self.parent                         : parent gtk window
    """

    def init(self):
        pass

    def select(self,cde,list):

        # get the XSL files
        XSL = ["xsl/"+i for i in os.listdir("xsl")]

        window_export = WindowExport()

        window_export.entry.set_text( self.conf["path"] or "" )
        window_export.notebook1.set_current_page(self.conf["mode"] or 0)
        window_export.hscale_quality.set_value( float(self.conf["quality"] or 100.0) )
        window_export.hscale_size.set_value( float(self.conf["size"] or 100.0))
        window_export.setList( XSL ,self.conf["xsl"] or 0)

        window_export.run()
        if window_export.reponse:
            path,mode,qual,size,idXsl = window_export.reponse
            self.conf["path"]=path
            self.conf["mode"]=mode
            self.conf["quality"]=qual
            self.conf["size"]=size
            self.conf["xsl"]=idXsl

            del(window_export)

            dir = path
            dirImg = os.path.join(dir,"img")
            dirThumbs = os.path.join(dir,"thumbs")

            if not os.path.isdir(dirImg):
                os.mkdir( dirImg )
            if not os.path.isdir(dirThumbs):
                os.mkdir( dirThumbs )
            try:
                nodeAlbum = Element("export")
                for pnode in list:
                    self.showProgress( list.index(pnode), len(list) , _("Exporting to Html") )
                    file = pnode.file

                    nodeImg = Element("img")

                    # Create the image File
                    #---------------------------------------------------------------
                    dest = os.path.join( dirImg, pnode.name)
                    if os.path.isfile(dest): os.unlink(dest)

                    if mode==1: # reduced
                        pb = pnode.getImage() # a gtk.PixBuf
                        (wx,wy) = pb.get_width(),pb.get_height()
                        wx = int(wx*size / 100)
                        wy = int(wy*size / 100)
                        pb = pb.scale_simple(wx,wy,3)   # 3= best quality (gtk.gdk.INTERP_HYPER)
                        pb.save(dest, "jpeg", {"quality":str(int(qual))})
                    else:
                        shutil.copy2(file,dest)

                    nodeImg.set("src","img/"+pnode.name)

                    # Create the Thumbs
                    #---------------------------------------------------------------
                    dest = os.path.join( dirThumbs, pnode.name)
                    if os.path.isfile(dest): os.unlink(dest)

                    pb = pnode.getBThumb()
                    pb.save(dest, "jpeg", {"quality":"80"})

                    nodeImg.set("mini","thumbs/"+pnode.name)

                    nodeImg.set("albumComment",pnode.getParent().comment)
                    nodeImg.set("album",pnode.getParent().name)
                    nodeImg.set("comment",pnode.comment)
                    nodeImg.set("tags",", ".join(pnode.tags))
                    nodeImg.set("hdate",cd2rd(pnode.date))  # human date ;-)
                    nodeImg.set("date",pnode.date)

                    nodeAlbum.append(nodeImg)

                xml_doc = ElementTree(nodeAlbum)

                # save a copy of the xml used file for info (can be deleted)
                fid = open(dir+"/photos.xml","w")
                xml_doc.write(fid)
                fid.close()

                xslt_doc = parse( XSL[idXsl] )
                nodeParams = xslt_doc.xpath("//xsl:param",{"xsl":"http://www.w3.org/1999/XSL/Transform"})

                p=1
                while True:

                    # the worst way to pass a param ;-)
                    nodeParams[0].text=str(p)
                    #~ nodeParams[1].text="8"

                    style = XSLT(xslt_doc)

                    result = style.apply( xml_doc)
                    page = style.tostring(result)
                    if "body" in page:
                        open(dir+"/page%d.html" % p,"w").write(page)
                        p+=1
                    else:
                        break;
            finally:
                self.showProgress()

        return False

def cd2rd(f): #yyyymmddhhiiss -> dd/mm/yyyy hh:ii:ss
   if f:
      if len(f) == 14:
         return f[6:8]+"/"+f[4:6]+"/"+f[:4]+" "+f[8:10]+":"+f[10:12]+":"+f[12:14]
      else:
         return f[6:8]+"/"+f[4:6]+"/"+f[:4]
   else:
      return f