#!/usr/bin/env python
# -*- coding: UTF8 -*-

##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##

# Python module export.py
# Autogenerated from export.glade
# Generated on Tue May  3 12:21:16 2005

# Warning: Do not delete or modify comments related to context
# They are required to keep user's code

import os
import gtk
from SimpleGladeApp import SimpleGladeApp
glade_dir = ""

# Put your modules and data here

# From here through main() codegen inserts/updates a class for
# every top-level widget in the .glade file.

class WindowExport(SimpleGladeApp):
    def __init__(self, glade_path="export.glade", root="windowExport", domain=None):
        glade_path = os.path.join(glade_dir, glade_path)
        SimpleGladeApp.__init__(self, glade_path, root, domain)

    def new(self):
        #context WindowExport.new {
        self.main_widget.set_modal(True)
        self.main_widget.set_keep_above(True)
        self.main_widget.set_position(gtk.WIN_POS_CENTER)

        # prepare the display of the combo
        cell = gtk.CellRendererText()
        self.combo.pack_start(cell, True)
        self.combo.add_attribute(cell, 'text',0)
        
        self.setList([],0)
        
        
        #context WindowExport.new }

    #context WindowExport custom methods {
    #--- Write your own methods here ---#
    def setList(self,list,n):
        m=gtk.ListStore( str)
        m.clear()
        for i in list:
            m.append( [i,] )
        self.combo.set_model(m)
        
        self.combo.set_active(n)
        
    #context WindowExport custom methods }

    def on_windowExport_delete_event(self, widget, *args):
        #context WindowExport.on_windowExport_delete_event {
        self.reponse=False
        gtk.main_quit()
        #context WindowExport.on_windowExport_delete_event }

    def on_button_select_folder_clicked(self, widget, *args):
        #context WindowExport.on_button_select_folder_clicked {
        dialog = gtk.FileChooserDialog ("Select mount point directory",
             None, gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
             (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN,
              gtk.RESPONSE_OK))
        dialog.set_default_response (gtk.RESPONSE_OK)
        #~ dialog.set_transient_for (self.dlg_add)
        
        # preselect the previous mount point
        dialog.select_filename (self.entry.get_text())
        
        response = dialog.run ()
        if response == gtk.RESPONSE_OK:
              self.entry.set_text( dialog.get_filename() )
        
        dialog.destroy()        
        #context WindowExport.on_button_select_folder_clicked }

    def on_button_appliquer_clicked(self, widget, *args):
        #context WindowExport.on_button_appliquer_clicked {
        self.reponse=(self.entry.get_text(),self.notebook1.get_current_page(),self.hscale_quality.get_value(),self.hscale_size.get_value(),self.combo.get_active() )
        self.main_widget.destroy()
        gtk.main_quit()
        #context WindowExport.on_button_appliquer_clicked }

    def on_button_annuler_clicked(self, widget, *args):
        #context WindowExport.on_button_annuler_clicked {
        self.reponse=False
        self.main_widget.destroy()
        gtk.main_quit()
        #context WindowExport.on_button_annuler_clicked }

def main():
    window_export = WindowExport()

    window_export.run()

if __name__ == "__main__":
    main()
    
