#!/usr/bin/env python
# -*- coding: UTF8 -*-
##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
# Python module redate.py
# Autogenerated from redate.glade
# Generated on Fri May  6 13:28:39 2005

# Warning: Do not delete or modify comments related to context
# They are required to keep user's code

import os
import gtk
from SimpleGladeApp import SimpleGladeApp

glade_dir = ""

# Put your modules and data here

from datetime import datetime,timedelta

# From here through main() codegen inserts/updates a class for
# every top-level widget in the .glade file.

class WinRedate(SimpleGladeApp):
    def __init__(self, glade_path="redate.glade", root="WinRedate", domain=None):
        glade_path = os.path.join(glade_dir, glade_path)
        SimpleGladeApp.__init__(self, glade_path, root, domain)

    def new(self):
        #context WinRedate.new {
        self.main_widget.set_modal(True)
        self.main_widget.set_keep_above(True)
        self.main_widget.set_position(gtk.WIN_POS_CENTER)
        
        try:
            self.d = WinRedate.defaultDate
        except:
            self.d = datetime.now() # just for self run
        self.recalc()
        #context WinRedate.new }

    #context WinRedate custom methods {
    #--- Write your own methods here ---#
    
    def recalc(self):
        vw= self.weeks.get_value()
        vd= self.days.get_value()
        vh= self.hours.get_value()
        vi= self.minutes.get_value()
        vs= self.seconds.get_value()
        
        f = lambda x: x.strftime("%d/%m/%Y %H:%M:%S")
      
        dn=self.d
        dn+=timedelta(weeks=vw, days=vd,hours=vh,minutes=vi,seconds=vs)
        
        msg = "Example date :\n"+f(self.d) +"\n\n"
        if vw == vd == vh == vi == vs == 0:
            self.vals = None
            msg += "No change"
        else:
            self.vals = (vw,vd,vh,vi,vs)
            msg += "Change to :\n"+ f(dn) +"\n"
        self.msg.set_text(msg)
         
    #context WinRedate custom methods }

    def on_WinRedate_delete_event(self, widget, *args):
        #context WinRedate.on_WinRedate_delete_event {
        self.reponse=False
        gtk.main_quit()

        #context WinRedate.on_WinRedate_delete_event }

    def on_weeks_value_changed(self, widget, *args):
        #context WinRedate.on_weeks_value_changed {
        self.recalc()
        #context WinRedate.on_weeks_value_changed }

    def on_days_value_changed(self, widget, *args):
        #context WinRedate.on_days_value_changed {
        self.recalc()

        #context WinRedate.on_days_value_changed }

    def on_hours_value_changed(self, widget, *args):
        #context WinRedate.on_hours_value_changed {
        self.recalc()

        #context WinRedate.on_hours_value_changed }

    def on_minutes_value_changed(self, widget, *args):
        #context WinRedate.on_minutes_value_changed {
        self.recalc()

        #context WinRedate.on_minutes_value_changed }

    def on_seconds_value_changed(self, widget, *args):
        #context WinRedate.on_seconds_value_changed {
        self.recalc()

        #context WinRedate.on_seconds_value_changed }

    def on_btn_annuler_clicked(self, widget, *args):
        #context WinRedate.on_btn_annuler_clicked {
        self.reponse=False
        self.main_widget.destroy()
        gtk.main_quit()
        #context WinRedate.on_btn_annuler_clicked }

    def on_btn_appliquer_clicked(self, widget, *args):
        #context WinRedate.on_btn_appliquer_clicked {
        self.reponse=self.vals
        self.main_widget.destroy()
        gtk.main_quit()


        #context WinRedate.on_btn_appliquer_clicked }

def main():
    win_redate = WinRedate()

    win_redate.run()

if __name__ == "__main__":
    main()
